Index: src/sans/fit/ScipyFitting.py
===================================================================
--- src/sans/fit/ScipyFitting.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/fit/ScipyFitting.py	(revision 8d074d926d99193a8c902448957d621abd9235d5)
@@ -1,4 +1,2 @@
-
-
 """
 ScipyFitting module contains FitArrange , ScipyFit,
@@ -6,14 +4,136 @@
 simple fit with scipy optimizer.
 """
+import sys
+import copy
 
 import numpy 
-import sys
-
 
 from sans.fit.AbstractFitEngine import FitEngine
-from sans.fit.AbstractFitEngine import SansAssembly
-from sans.fit.AbstractFitEngine import FitAbort
-from sans.fit.AbstractFitEngine import Model
-from sans.fit.AbstractFitEngine import FResult 
+from sans.fit.AbstractFitEngine import FResult
+
+class SansAssembly:
+    """
+    Sans Assembly class a class wrapper to be call in optimizer.leastsq method
+    """
+    def __init__(self, paramlist, model=None, data=None, fitresult=None,
+                 handler=None, curr_thread=None, msg_q=None):
+        """
+        :param Model: the model wrapper fro sans -model
+        :param Data: the data wrapper for sans data
+
+        """
+        self.model = model
+        self.data = data
+        self.paramlist = paramlist
+        self.msg_q = msg_q
+        self.curr_thread = curr_thread
+        self.handler = handler
+        self.fitresult = fitresult
+        self.res = []
+        self.true_res = []
+        self.func_name = "Functor"
+        self.theory = None
+
+    def chisq(self):
+        """
+        Calculates chi^2
+
+        :param params: list of parameter values
+
+        :return: chi^2
+
+        """
+        total = 0
+        for item in self.true_res:
+            total += item * item
+        if len(self.true_res) == 0:
+            return None
+        return total / (len(self.true_res) - len(self.paramlist))
+
+    def __call__(self, params):
+        """
+            Compute residuals
+            :param params: value of parameters to fit
+        """
+        #import thread
+        self.model.set_params(self.paramlist, params)
+        #print "params", params
+        self.true_res, theory = self.data.residuals(self.model.eval)
+        self.theory = copy.deepcopy(theory)
+        # check parameters range
+        if self.check_param_range():
+            # if the param value is outside of the bound
+            # just silent return res = inf
+            return self.res
+        self.res = self.true_res
+
+        if self.fitresult is not None:
+            self.fitresult.set_model(model=self.model)
+            self.fitresult.residuals = self.true_res
+            self.fitresult.iterations += 1
+            self.fitresult.theory = theory
+
+            #fitness = self.chisq(params=params)
+            fitness = self.chisq()
+            self.fitresult.pvec = params
+            self.fitresult.set_fitness(fitness=fitness)
+            if self.msg_q is not None:
+                self.msg_q.put(self.fitresult)
+
+            if self.handler is not None:
+                self.handler.set_result(result=self.fitresult)
+                self.handler.update_fit()
+
+            if self.curr_thread != None:
+                try:
+                    self.curr_thread.isquit()
+                except:
+                    #msg = "Fitting: Terminated...       Note: Forcing to stop "
+                    #msg += "fitting may cause a 'Functor error message' "
+                    #msg += "being recorded in the log file....."
+                    #self.handler.stop(msg)
+                    raise
+
+        return self.res
+
+    def check_param_range(self):
+        """
+        Check the lower and upper bound of the parameter value
+        and set res to the inf if the value is outside of the
+        range
+        :limitation: the initial values must be within range.
+        """
+
+        #time.sleep(0.01)
+        is_outofbound = False
+        # loop through the fit parameters
+        model = self.model.model
+        for p in self.paramlist:
+            value = model.getParam(p)
+            low,high = model.details[p][1:3]
+            if low is not None and numpy.isfinite(low):
+                if p.value == 0:
+                    # This value works on Scipy
+                    # Do not change numbers below
+                    value = _SMALLVALUE
+                # For leastsq, it needs a bit step back from the boundary
+                val = low - value * _SMALLVALUE
+                if value < val:
+                    self.res *= 1e+6
+                    is_outofbound = True
+                    break
+            if high is not None and numpy.isfinite(high):
+                # This value works on Scipy
+                # Do not change numbers below
+                if value == 0:
+                    value = _SMALLVALUE
+                # For leastsq, it needs a bit step back from the boundary
+                val = high + value * _SMALLVALUE
+                if value > val:
+                    self.res *= 1e+6
+                    is_outofbound = True
+                    break
+
+        return is_outofbound
 
 class ScipyFit(FitEngine):
@@ -50,6 +170,4 @@
         """
         FitEngine.__init__(self)
-        self.fit_arrange_dict = {}
-        self.param_list = []
         self.curr_thread = None
     #def fit(self, *args, **kw):
@@ -68,8 +186,6 @@
             msg = "Scipy can't fit more than a single fit problem at a time."
             raise RuntimeError, msg
-            return
-        elif len(fitproblem) == 0 : 
+        elif len(fitproblem) == 0 :
             raise RuntimeError, "No Assembly scheduled for Scipy fitting."
-            return
         model = fitproblem[0].get_model()
         if reset_flag:
@@ -87,11 +203,17 @@
         
         # Check the initial value if it is within range
-        self._check_param_range(model)
+        _check_param_range(model.model, self.param_list)
         
-        result = FResult(model=model, data=data, param_list=self.param_list)
-        result.pars = fitproblem[0].pars
+        result = FResult(model=model.model, data=data, param_list=self.param_list)
         result.fitter_id = self.fitter_id
         if handler is not None:
             handler.set_result(result=result)
+        functor = SansAssembly(paramlist=self.param_list,
+                               model=model,
+                               data=data,
+                               handler=handler,
+                               fitresult=result,
+                               curr_thread=curr_thread,
+                               msg_q=msg_q)
         try:
             # This import must be here; otherwise it will be confused when more
@@ -99,15 +221,8 @@
             from scipy import optimize
             
-            functor = SansAssembly(paramlist=self.param_list, 
-                                   model=model, 
-                                   data=data,
-                                    handler=handler,
-                                    fitresult=result,
-                                     curr_thread=curr_thread,
-                                     msg_q=msg_q)
             out, cov_x, _, mesg, success = optimize.leastsq(functor,
                                             model.get_params(self.param_list),
-                                                    ftol=ftol,
-                                                    full_output=1)
+                                            ftol=ftol,
+                                            full_output=1)
         except:
             if hasattr(sys, 'last_type') and sys.last_type == KeyboardInterrupt:
@@ -142,58 +257,35 @@
 
         
-    def _check_param_range(self, model):
-        """
-        Check parameter range and set the initial value inside 
-        if it is out of range.
-        
-        : model: park model object
-        """
-        is_outofbound = False
-        # loop through parameterset
-        for p in model.parameterset:        
-            param_name = p.get_name()
-            # proceed only if the parameter name is in the list of fitting
-            if param_name in self.param_list:
-                # if the range was defined, check the range
-                if numpy.isfinite(p.range[0]):
-                    if p.value <= p.range[0]: 
-                        # 10 % backing up from the border if not zero
-                        # for Scipy engine to work properly.
-                        shift = self._get_zero_shift(p.range[0])
-                        new_value = p.range[0] + shift
-                        p.value =  new_value
-                        is_outofbound = True
-                if numpy.isfinite(p.range[1]):
-                    if p.value >= p.range[1]:
-                        shift = self._get_zero_shift(p.range[1])
-                        # 10 % backing up from the border if not zero
-                        # for Scipy engine to work properly.
-                        new_value = p.range[1] - shift
-                        # Check one more time if the new value goes below
-                        # the low bound, If so, re-evaluate the value 
-                        # with the mean of the range.
-                        if numpy.isfinite(p.range[0]):
-                            if new_value < p.range[0]:
-                                new_value = (p.range[0] + p.range[1]) / 2.0
-                        # Todo: 
-                        # Need to think about when both min and max are same.
-                        p.value =  new_value
-                        is_outofbound = True
-                        
-        return is_outofbound
-    
-    def _get_zero_shift(self, range):
-        """
-        Get 10% shift of the param value = 0 based on the range value
-        
-        : param range: min or max value of the bounds
-        """
-        if range == 0:
-            shift = 0.1
-        else:
-            shift = 0.1 * range
-            
-        return shift
-    
+def _check_param_range(model, param_list):
+    """
+    Check parameter range and set the initial value inside
+    if it is out of range.
+
+    : model: park model object
+    """
+    # loop through parameterset
+    for p in param_list:
+        value = model.getParam(p)
+        low,high = model.details.setdefault(p,["",None,None])[1:3]
+        # if the range was defined, check the range
+        if low is not None and value <= low:
+            value = low + _get_zero_shift(low)
+        if high is not None and value > high:
+            value = high - _get_zero_shift(high)
+            # Check one more time if the new value goes below
+            # the low bound, If so, re-evaluate the value
+            # with the mean of the range.
+            if low is not None and value < low:
+                value = 0.5 * (low+high)
+        model.setParam(p, value)
+
+def _get_zero_shift(limit):
+    """
+    Get 10% shift of the param value = 0 based on the range value
+
+    : param range: min or max value of the bounds
+    """
+    return 0.1 * (limit if limit != 0.0 else 1.0)
+
     
 #def profile(fn, *args, **kw):
Index: src/sans/fit/__init__.py
===================================================================
--- src/sans/fit/__init__.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/fit/__init__.py	(revision 6fe51002a81260397b29374005fb3e465ff93b4a)
@@ -0,0 +1,1 @@
+from .AbstractFitEngine import FitHandler
Index: src/sans/fit/expression.py
===================================================================
--- src/sans/fit/expression.py	(revision 4e9f22702695459c7a6c8721061aab9d9e4ef437)
+++ src/sans/fit/expression.py	(revision 4e9f22702695459c7a6c8721061aab9d9e4ef437)
@@ -0,0 +1,400 @@
+# This program is public domain
+"""
+Parameter expression evaluator.
+
+For systems in which constraints are expressed as string expressions rather
+than python code, :func:`compile_constraints` can construct an expression
+evaluator that substitutes the computed values of the expressions into the
+parameters.
+
+The compiler requires a symbol table, an expression set and a context.
+The symbol table maps strings containing fully qualified names such as
+'M1.c[3].full_width' to parameter objects with a 'value' property that
+can be queried and set.  The expression set maps symbol names from the
+symbol table to string expressions.  The context provides additional symbols
+for the expressions in addition to the usual mathematical functions and
+constants.
+
+The expressions are compiled and interpreted by python, with only minimal
+effort to make sure that they don't contain bad code.  The resulting
+constraints function returns 0 so it can be used directly in a fit problem
+definition.
+
+Extracting the symbol table from the model depends on the structure of the
+model.  If fitness.parameters() is set correctly, then this should simply
+be a matter of walking the parameter data, remembering the path to each
+parameter in the symbol table.  For compactness, dictionary elements should
+be referenced by .name rather than ["name"].  Model name can be used as the
+top level.
+
+Getting the parameter expressions applied correctly is challenging.
+The following monkey patch works by overriding model_update in FitProblem
+so that after setp(p) is called and, the constraints expression can be
+applied before telling the underlying fitness function that the model
+is out of date::
+
+        # Override model update so that parameter constraints are applied
+        problem._model_update = problem.model_update
+        def model_update():
+            constraints()
+            problem._model_update()
+        problem.model_update = model_update
+
+Ideally, this interface will change
+"""
+import math
+import re
+
+# simple pattern which matches symbols.  Note that it will also match
+# invalid substrings such as a3...9, but given syntactically correct
+# input it will only match symbols.
+_symbol_pattern = re.compile('([a-zA-Z_][a-zA-Z_0-9.]*)')
+
+def _symbols(expr,symtab):
+    """
+    Given an expression string and a symbol table, return the set of symbols
+    used in the expression.  Symbols are only returned once even if they
+    occur multiple times.  The return value is a set with the elements in
+    no particular order.
+    
+    This is the first step in computing a dependency graph.
+    """
+    matches = [m.group(0) for m in _symbol_pattern.finditer(expr)]
+    return set([symtab[m] for m in matches if m in symtab])
+
+def _substitute(expr,mapping):
+    """
+    Replace all occurrences of symbol s with mapping[s] for s in mapping.
+    """
+    # Find the symbols and the mapping
+    matches = [(m.start(),m.end(),mapping[m.group(1)])
+               for m in _symbol_pattern.finditer(expr)
+               if m.group(1) in mapping]
+
+    # Split the expression in to pieces, with new symbols replacing old
+    pieces = []
+    offset = 0
+    for start,end,text in matches:
+        pieces += [expr[offset:start],text]
+        offset = end
+    pieces.append(expr[offset:])
+    
+    # Join the pieces and return them
+    return "".join(pieces)
+
+def _find_dependencies(symtab, exprs):
+    """
+    Returns a list of pair-wise dependencies from the parameter expressions.
+    
+    For example, if p3 = p1+p2, then find_dependencies([p1,p2,p3]) will
+    return [(p3,p1),(p3,p2)].  For base expressions without dependencies,
+    such as p4 = 2*pi, this should return [(p4, None)]
+    """
+    deps = [(target,source)
+            for target,expr in exprs.items()
+            for source in _symbols_or_none(expr,symtab)]
+    return deps
+
+# Hack to deal with expressions without dependencies --- return a fake
+# dependency of None.
+# The better solution is fix order_dependencies so that it takes a
+# dictionary of {symbol: dependency_list}, for which no dependencies
+# is simply []; fix in parameter_mapping as well
+def _symbols_or_none(expr,symtab):
+    syms = _symbols(expr,symtab)
+    return syms if len(syms) else [None]
+
+def _parameter_mapping(pairs):
+    """
+    Find the parameter substitution we need so that expressions can
+    be evaluated without having to traverse a chain of 
+    model.layer.parameter.value
+    """
+    left,right = zip(*pairs)
+    pars = list(sorted(p for p in set(left+right) if p is not None))
+    definition = dict( ('P%d'%i,p)  for i,p in enumerate(pars) )
+    # p is None when there is an expression with no dependencies
+    substitution = dict( (p,'P%d.value'%i)
+                    for i,p in enumerate(sorted(pars))
+                    if p is not None)
+    return definition, substitution
+
+def no_constraints(): 
+    """
+    This parameter set has no constraints between the parameters.
+    """
+    pass
+
+def compile_constraints(symtab, exprs, context={}):
+    """
+    Build and return a function to evaluate all parameter expressions in
+    the proper order.
+
+    Input:
+
+        *symtab* is the symbol table for the model: { 'name': parameter }
+
+        *exprs* is the set of computed symbols: { 'name': 'expression' }
+
+        *context* is any additional context needed to evaluate the expression
+
+    Return:
+
+        updater function which sets parameter.value for each expression
+
+    Raises:
+
+       AssertionError - model, parameter or function is missing
+
+       SyntaxError - improper expression syntax
+
+       ValueError - expressions have circular dependencies
+
+    This function is not terribly sophisticated, and it would be easy to
+    trick.  However it handles the common cases cleanly and generates
+    reasonable messages for the common errors.
+
+    This code has not been fully audited for security.  While we have
+    removed the builtins and the ability to import modules, there may
+    be other vectors for users to perform more than simple function
+    evaluations.  Unauthenticated users should not be running this code.
+
+    Parameter names are assumed to contain only _.a-zA-Z0-9#[]
+    
+    Both names are provided for inverse functions, e.g., acos and arccos.
+
+    Should try running the function to identify syntax errors before
+    running it in a fit.
+    
+    Use help(fn) to see the code generated for the returned function fn.
+    dis.dis(fn) will show the corresponding python vm instructions.
+    """
+
+    # Sort the parameters in the order they need to be evaluated
+    deps = _find_dependencies(symtab, exprs)
+    if deps == []: return no_constraints
+    order = order_dependencies(deps)
+
+
+    # Rather than using the full path to the parameters in the parameter
+    # expressions, instead use Pn, and substitute Pn.value for each occurrence
+    # of the parameter in the expression.
+    names = list(sorted(symtab.keys()))
+    parameters = dict(('P%d'%i, symtab[k]) for i,k in enumerate(names))
+    mapping = dict((k, 'P%d.value'%i) for i,k in enumerate(names))
+
+
+    # Initialize dictionary with available functions
+    globals = {}
+    globals.update(math.__dict__)
+    globals.update(dict(arcsin=math.asin,arccos=math.acos,
+                        arctan=math.atan,arctan2=math.atan2))
+    globals.update(context)
+    globals.update(parameters)
+    globals['id'] = id
+    locals = {}
+
+    # Define the constraints function
+    assignments = ["=".join((p,exprs[p])) for p in order]
+    code = [_substitute(s, mapping) for s in assignments]
+    functiondef = """
+def eval_expressions():
+    '''
+    %s
+    '''
+    %s
+    return 0
+"""%("\n    ".join(assignments),"\n    ".join(code))
+
+    #print("Function: "+functiondef)
+    exec functiondef in globals,locals
+    retfn = locals['eval_expressions']
+
+    # Remove garbage added to globals by exec
+    globals.pop('__doc__',None)
+    globals.pop('__name__',None)
+    globals.pop('__file__',None)
+    globals.pop('__builtins__')
+    #print globals.keys()
+
+    return retfn
+
+def order_dependencies(pairs):
+    """
+    Order elements from pairs so that b comes before a in the
+    ordered list for all pairs (a,b).
+    """
+    #print "order_dependencies",pairs
+    emptyset = set()
+    order = []
+
+    # Break pairs into left set and right set
+    left,right = [set(s) for s in zip(*pairs)] if pairs != [] else ([],[])
+    while pairs != []:
+        #print "within",pairs
+        # Find which items only occur on the right
+        independent = right - left
+        if independent == emptyset:
+            cycleset = ", ".join(str(s) for s in left)
+            raise ValueError,"Cyclic dependencies amongst %s"%cycleset
+
+        # The possibly resolvable items are those that depend on the independents
+        dependent = set([a for a,b in pairs if b in independent])
+        pairs = [(a,b) for a,b in pairs if b not in independent]
+        if pairs == []:
+            resolved = dependent
+        else:
+            left,right = [set(s) for s in zip(*pairs)]
+            resolved = dependent - left
+        #print "independent",independent,"dependent",dependent,"resolvable",resolved
+        order += resolved
+        #print "new order",order
+    order.reverse()
+    return order
+
+# ========= Test code ========
+def _check(msg,pairs):
+    """
+    Verify that the list n contains the given items, and that the list
+    satisfies the partial ordering given by the pairs in partial order.
+    """
+    left,right = zip(*pairs) if pairs != [] else ([],[])
+    items = set(left)
+    n = order_dependencies(pairs)
+    if set(n) != items or len(n) != len(items):
+        n.sort()
+        items = list(items); items.sort()
+        raise Exception,"%s expect %s to contain %s for %s"%(msg,n,items,pairs)
+    for lo,hi in pairs:
+        if lo in n and hi in n and n.index(lo) >= n.index(hi):
+            raise Exception,"%s expect %s before %s in %s for %s"%(msg,lo,hi,n,pairs)
+
+def test_deps():
+    import numpy
+
+    # Null case
+    _check("test empty",[])
+
+    # Some dependencies
+    _check("test1",[(2,7),(1,5),(1,4),(2,1),(3,1),(5,6)])
+    _check("test1 renumbered",[(6,1),(7,3),(7,4),(6,7),(5,7),(3,2)])
+    _check("test1 numpy",numpy.array([(2,7),(1,5),(1,4),(2,1),(3,1),(5,6)]))
+
+    # No dependencies
+    _check("test2",[(4,1),(3,2),(8,4)])
+
+    # Cycle test
+    pairs = [(1,4),(4,3),(4,5),(5,1)]
+    try: n = order_dependencies(pairs)
+    except ValueError: pass
+    else: raise Exception,"test3 expect ValueError exception for %s"%(pairs,)
+
+    # large test for gross speed check
+    A = numpy.random.randint(4000,size=(1000,2))
+    A[:,1] += 4000  # Avoid cycles
+    _check("test-large",A)
+
+    # depth tests
+    k = 200
+    A = numpy.array([range(0,k),range(1,k+1)]).T
+    _check("depth-1",A)
+
+    A = numpy.array([range(1,k+1),range(0,k)]).T
+    _check("depth-2",A)
+
+def test_expr():
+    import inspect, dis
+    import math
+    
+    symtab = {'a.b.x':1, 'a.c':2, 'a.b':3, 'b.x':4}
+    expr = 'a.b.x + sin(4*pi*a.c) + a.b.x/a.b'
+    
+    # Check symbol lookup
+    assert _symbols(expr, symtab) == set([1,2,3])
+
+    # Check symbol rename
+    assert _substitute(expr,{'a.b.x':'Q'}) == 'Q + sin(4*pi*a.c) + Q/a.b'
+    assert _substitute(expr,{'a.b':'Q'}) == 'a.b.x + sin(4*pi*a.c) + a.b.x/Q'
+
+
+    # Check dependency builder
+    # Fake parameter class
+    class Parameter:
+        def __init__(self, name, value=0, expression=''):
+            self.path = name
+            self.value = value
+            self.expression = expression
+        def iscomputed(self): return (self.expression != '')
+        def __repr__(self): return self.path
+    def world(*pars):
+        symtab = dict((p.path,p) for p in pars)
+        exprs = dict((p.path,p.expression) for p in pars if p.iscomputed())
+        return symtab, exprs
+    p1 = Parameter('G0.sigma',5)
+    p2 = Parameter('other',expression='2*pi*sin(G0.sigma/.1875) + M1.G1')
+    p3 = Parameter('M1.G1',6)
+    p4 = Parameter('constant',expression='2*pi*35')
+    # Simple chain
+    assert set(_find_dependencies(*world(p1,p2,p3))) == set([(p2.path,p1),(p2.path,p3)])
+    # Constant expression
+    assert set(_find_dependencies(*world(p1,p4))) == set([(p4.path,None)])
+    # No dependencies
+    assert set(_find_dependencies(*world(p1,p3))) == set([])
+
+    # Check function builder
+    fn = compile_constraints(*world(p1,p2,p3))
+
+    # Inspect the resulting function
+    if 0:
+        print(inspect.getdoc(fn))
+        print(dis.dis(fn))
+
+    # Evaluate the function and see if it updates the
+    # target value as expected
+    fn()
+    expected = 2*math.pi*math.sin(5/.1875) + 6
+    assert p2.value == expected,"Value was %s, not %s"%(p2.value,expected)
+    
+    # Check empty dependency set doesn't crash
+    fn = compile_constraints(*world(p1,p3))
+    fn()
+
+    # Check that constants are evaluated properly
+    fn = compile_constraints(*world(p4))
+    fn()
+    assert p4.value == 2*math.pi*35
+
+    # Check additional context example; this also tests multiple
+    # expressions
+    class Table:
+        Si = 2.09
+        values = {'Si': 2.07}
+    tbl = Table()
+    p5 = Parameter('lookup',expression="tbl.Si")
+    fn = compile_constraints(*world(p1,p2,p3,p5),context=dict(tbl=tbl))
+    fn()
+    assert p5.value == 2.09,"Value for %s was %s"%(p5.expression,p5.value)
+    p5.expression = "tbl.values['Si']"
+    fn = compile_constraints(*world(p1,p2,p3,p5),context=dict(tbl=tbl))
+    fn()
+    assert p5.value == 2.07,"Value for %s was %s"%(p5.expression,p5.value)
+    
+
+    # Verify that we capture invalid expressions
+    for expr in ['G4.cage', 'M0.cage', 'M1.G1 + *2', 
+                 'piddle',
+                 '5; import sys; print "p0wned"',
+                 '__import__("sys").argv']:
+        try:
+            p6 = Parameter('broken',expression=expr)
+            fn = compile_constraints(*world(p6))
+            fn()
+        except Exception as msg:
+            #print(msg)
+            pass
+        else:
+            raise "Failed to raise error for %s"%expr
+
+if __name__ == "__main__":
+    test_expr()
+    test_deps()
Index: src/sans/perspectives/fitting/basepage.py
===================================================================
--- src/sans/perspectives/fitting/basepage.py	(revision 116e1a745c824ae90452a0a866bede4b161d79f5)
+++ src/sans/perspectives/fitting/basepage.py	(revision 116e1a745c824ae90452a0a866bede4b161d79f5)
@@ -835,6 +835,6 @@
             infor = "warning"
         else:
-            msg = "Error was occured "
-            msg += ": No valid parameter values to paste from the clipboard..."
+            msg = "Error occured: "
+            msg += "No valid parameter values to paste from the clipboard..."
             infor = "error"
             wx.PostEvent(self._manager.parent,
@@ -2183,10 +2183,10 @@
                 else:
                     tcrtl.SetBackgroundColour("pink")
-                    msg = "Model Error:wrong value entered: %s" % sys.exc_value
+                    msg = "Model Error: wrong value entered: %s" % sys.exc_value
                     wx.PostEvent(self.parent, StatusEvent(status=msg))
                     return
             except:
                 tcrtl.SetBackgroundColour("pink")
-                msg = "Model Error:wrong value entered: %s" % sys.exc_value
+                msg = "Model Error: wrong value entered: %s" % sys.exc_value
                 wx.PostEvent(self.parent, StatusEvent(status=msg))
                 return
@@ -2199,9 +2199,9 @@
                         #is_modified = True
                 else:
-                    msg = "Cannot Plot :No npts in that Qrange!!!  "
+                    msg = "Cannot plot: No points in Q range!!!  "
                     wx.PostEvent(self.parent, StatusEvent(status=msg))
         else:
             tcrtl.SetBackgroundColour("pink")
-            msg = "Model Error:wrong value entered!!!"
+            msg = "Model Error: wrong value entered!!!"
             wx.PostEvent(self.parent, StatusEvent(status=msg))
         self.save_current_state()
@@ -2240,10 +2240,10 @@
                 else:
                     tcrtl.SetBackgroundColour("pink")
-                    msg = "Model Error:wrong value entered: %s" % sys.exc_value
+                    msg = "Model Error: wrong value entered: %s" % sys.exc_value
                     wx.PostEvent(self._manager.parent, StatusEvent(status=msg))
                     return
             except:
                 tcrtl.SetBackgroundColour("pink")
-                msg = "Model Error:wrong value entered: %s" % sys.exc_value
+                msg = "Model Error: wrong value entered: %s" % sys.exc_value
                 wx.PostEvent(self._manager.parent, StatusEvent(status=msg))
                 return
@@ -2256,9 +2256,9 @@
                         is_modified = True
                 else:
-                    msg = "Cannot Plot :No npts in that Qrange!!!  "
+                    msg = "Cannot Plot: No points in Q range!!!  "
                     wx.PostEvent(self._manager.parent, StatusEvent(status=msg))
         else:
             tcrtl.SetBackgroundColour("pink")
-            msg = "Model Error:wrong value entered!!!"
+            msg = "Model Error: wrong value entered!!!"
             wx.PostEvent(self._manager.parent, StatusEvent(status=msg))
         self.save_current_state()
@@ -2431,6 +2431,6 @@
                 self.qmax.SetBackgroundColour("pink")
                 self.qmax.Refresh()
-                msg = "Npts of Data Error :"
-                msg += "No or too little npts of %s." % data.name
+                msg = "Data Error: "
+                msg += "Too few points in %s." % data.name
                 wx.PostEvent(self._manager.parent, StatusEvent(status=msg))
                 self.fitrange = False
@@ -2466,6 +2466,6 @@
                 self.qmax.SetBackgroundColour("pink")
                 self.qmax.Refresh()
-                msg = "Npts of Data Error :"
-                msg += "No or too little npts of %s." % data.name
+                msg = "Data Error: "
+                msg += "Too few points in %s." % data.name
                 wx.PostEvent(self._manager.parent, StatusEvent(status=msg))
                 self.fitrange = False
@@ -2518,5 +2518,5 @@
                                            
                         except:
-                            msg = "Wrong Fit parameter range entered "
+                            msg = "Wrong fit parameter range entered"
                             wx.PostEvent(self._manager.parent,
                                          StatusEvent(status=msg))
Index: src/sans/perspectives/fitting/console.py
===================================================================
--- src/sans/perspectives/fitting/console.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/perspectives/fitting/console.py	(revision 644ca73017baa0189f6424c93e070248941b265a)
@@ -5,6 +5,5 @@
 import time
 import wx
-import park
-from park.fitresult import FitHandler
+from sans.fit import FitHandler
 
 class ConsoleUpdate(FitHandler):
@@ -88,5 +87,5 @@
         Print result object
         """
-        msg = " \n %s \n" % self.result.__str__()
+        msg = " \n %s \n" % str(self.result)
         wx.PostEvent(self.parent, StatusEvent(status=msg))
                      
@@ -137,5 +136,5 @@
         self.fit_duration += self.elapsed_time
         str_time = time.strftime("%a, %d %b %Y %H:%M:%S ", time.localtime(t1))
-        UPDATE_INTERVAL = 0.5
+        UPDATE_INTERVAL = 5.0
         u_flag = False
         if self.fit_duration >= UPDATE_INTERVAL:
